'<TiCoBasic Header, Headerversion 001.001>
' Foldings                       = 29,68,142,471,510,604,915
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'##############################################################################
'#                        MIO_TiCO.inc                                        #
'#              INCLUDE-file for MIO-4                                        #
'##############################################################################
'#                                                                            #
'#                                                                            #
'#  15.12.2008  mf   creation                                                 #
'#  15.01.2009  mf   mio_digout                                               #
'#  30.01.2009  mf   seq                                                      #
'#  24.02.2009  mf   mio_digout                                               # 
'#  17.03.2009  mf   '''+                                                     #
'#  29.07.2009  mf   mio_et1                                                  #
'#  06.08.2009  ur   EtherCAT                                                 #
'#  24.09.2009  mf   EtherCAT Error-LED                                       #
'#  02.10.2009  ur   EtherCAT defines                                         #
'#  26.10.2009  ur   EtherCAT                                                 #
'#  18.03.2010  mf   wait_mux                                                 #
'#                                                                            #
'# Attention:                                                                 #
'#   - Do not copy the first source line (containing                          #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !                             #
'#     Otherwise the Syntax color may be not correct.                         #
'#   - This includefile requires ADbasic 5 or higher!                         #
'#  Eventsource with clear (108041E0H) without clear (108041E1H) Bit 16       #
'##############################################################################

'<REGION> DECLARATION
#define ECAT_REG_TYPE_RESET_VALUE 00011h                    '<HIDE>
#define ECAT_DRIVER_VERSION_MAJOR 1                         '<HIDE>
#define ECAT_DRIVER_VERSION_MINOR 0                         '<HIDE>
' Registers of the ESC20/ET1100
#define ECAT_REG_Type              00000h                   '<HIDE>   ' 1 byte
#define ECAT_REG_AL_Control        00120h                   '<HIDE>   ' 5 bit
#define ECAT_REG_AL_Status         00130h                   '<HIDE>   ' 1 byte
#define ECAT_REG_AL_Status_Code    00134h                   '<HIDE>   ' 2 bytes
#define ECAT_RXPDO_START           01000h                   '<HIDE>
#define ECAT_TXPDO_START           01100h                   '<HIDE>
#define ECAT_STATE_INIT            0001h                    '<HIDE>
#define ECAT_STATE_PREOP           0002h                    '<HIDE>
#define ECAT_STATE_BOOT            0003h                    '<HIDE>
#define ECAT_STATE_SAFEOP          0004h                    '<HIDE>
#define ECAT_STATE_OP              0008h                    '<HIDE>
' size of input and output datas
#define ECAT_RXPDO_COUNT_16L   16                           '<HIDE>
#define ECAT_TXPDO_COUNT_16L   16                           '<HIDE>
' Blink pattern
#define ECAT_BP_OFF              0                          '<HIDE>
#define ECAT_BP_ON               1                          '<HIDE>
#define ECAT_BP_FLICKERING      010110h                     '<HIDE>
#define ECAT_BP_BLINKING        010440h                     '<HIDE>
#define ECAT_BP_SINGLE_FLASH    011440h                     '<HIDE>
#define ECAT_BP_DOUBLE_FLASH    021440h                     '<HIDE>
#define ECAT_BP_TRIPLE_FLASH    031440h                     '<HIDE>

#if adwin_system = ADwin_ProII
#else
#error("This include file can only be used with the ADwin ProII")  
#endif

#If MAKE_LIB = OFF Then
dim PWM_help_mode as long                                   '<HIDE>
#endif

'<ENDREGION>

'<REGION> System

'******************************************************************************
''' Reads the event inputs
'''****************************************************************************
FUNCTION Event_Read() as Long
  Event_Read = in(7040h)
ENDFUNCTION



'*******************************************************************************
'''  activates or deactivates the external Event input
'''  value: 
'''+  0 deactivate
'''+  1 activate
'''*****************************************************************************
SUB Event_Enable(value)
  DIM old AS Long

  old = in(80804800h)
  old = (old AND 0FFFFFFFEH) or value
  out (80804800h, old)
ENDSUB

'*******************************************************************************
'''  config the external Event input
'''  min_hold: 0/1  0=15 ns (default) 1 =50 ns
'''  edge: 
'''+       1 rising edge (default)
'''+       2 falling edge
'''+       3 rising & falling edge
''' prescale: 1 to 255
'''*****************************************************************************
SUB Event_Config(min_hold, edge, prescale)
  DIM old AS Long
  DIM neu AS Long
  DIM value AS Long

  old = in(80804800h)

  neu = shift_left((min_hold AND 1), 4) or shift_left((edge AND 3), 2)
  old = (old AND 0FFFFFFE3H) or neu
  out (80804800h, old)
  value = prescale AND 0FFH
  out (80804810h, value)
ENDSUB

'*******************************************************************************
''' creat an event for the master cpu
'''*****************************************************************************
SUB Trigger_Event()
  out (108041E0h, 1)
ENDSUB

'******************************************************************************
''' switches a LED on or off
''' value: 
'''+   0 off
'''+   1 on
'''****************************************************************************
SUB Set_LED(value)
  out (80804000H, value)
ENDSUB

'******************************************************************************
''' checks the LED
'''****************************************************************************
FUNCTION Check_LED() AS LONG
  Check_LED = in(80804000h)
ENDFUNCTION

'<ENDREGION>

'<REGION> ADC

'******************************************************************************
''' Set MUX to desired input channel.
''' select: bit 9 & 8 -> gain, bit 3...0 -> channel 1...16
'''****************************************************************************
SUB Set_Mux(select)
  OUT(5010h, select)
ENDSUB

'********************************************************************************
'''wait the difference time between the last change of multiplexer and required time of the multiplexer
'''+the required time can be set with p2_seq_init
'''******************************************************************************
SUB Wait_Mux()
  DIM muxtime AS Long
  '............ wait multiplexer settling time ........
  nops(4)
  
  '............ wait multiplexer settling time ........
  muxtime=IN(5022h) '
  
  if (muxtime>6) then 
    SLEEP((muxtime/5)) 															
  endif

ENDSUB



'******************************************************************************
''' Selects single-ended (s.e.) or differential (diff.) inputs
''' mode: 
'''+     s.e. -> 0, 
'''+     diff. -> 1 (default after power-up)
'''****************************************************************************
SUB SE_Diff(mode)
  OUT(5012h, mode)
ENDSUB


'******************************************************************************
''' Start conversion of ADC.
'''****************************************************************************
SUB Start_Conv()
  OUT(00007000h, 1)
ENDSUB

'******************************************************************************
''' Wait until EOC-signal goes active (End Of Conversion).
'''****************************************************************************
SUB Wait_EOC()
  DIM reminder AS LONG

  '............ wait EOC ............
  nops(3)

  do
    reminder = IN(00007010h)
  until ((reminder AND 1) = 0)
ENDSUB


'******************************************************************************
''' Returns conversion result of ADC
'''+result: 16 bit integer
'''****************************************************************************
FUNCTION Read_ADC() AS LONG
  Read_ADC = IN(00000200h)
ENDFUNCTION

'******************************************************************************
''' Returns conversion result of ADC
'''+result: 24 bit integer
'''****************************************************************************
FUNCTION Read_ADC24() AS LONG
  Read_ADC24 = IN(00000000h)
ENDFUNCTION

'******************************************************************************
''' Samples, converts and reads out the digital ADC-value of an
'''+ analog input.
'''+ result: 16 bit integer
'''+ Attention:                                                                
'''+ This instruction is not prepared to handle an access from                 
'''+ a low AND high priority process to the same module.                       
'''adc_no: channel number of analog input
'''****************************************************************************
FUNCTION ADC(adc_no) AS LONG

  DIM reminder AS LONG
  DIM muxtime AS LONG

  '............ set MUX ............
  OUT(5010h, (adc_no - 1))

  nops(4)

  '............ wait multiplexer settling time ........
  muxtime = IN(5022h)                                       '

  if (muxtime > 6) then
    SLEEP((muxtime / 5))
  endif

  '............ start conversion ............

  OUT(00007000h, 1)

  ' folgende nops sind erforderlich, aufgrund fpga-interner zwischentaktung
  ' zur Verbesserung des fpga-timings.
  ' => unkritisch, da sowieso gewartet wird !

  nops(3)                                                   ' Out-Datum steht am Beginn diese NOP bereits an  __|--
  ' Busy_adc (=STCONV) auf '1' zu Beginn dieses NOP ____|--
  ' Busy_out           auf '1' zu Beginn dieses NOP ______|--
  ' => Busy_out kann mit dem nchsten IN-Befehl gelesen werden

  '............ wait EOC ............
  do
    ' EOC, d.h. Busy_out='0' mit 1-Taktzyklus langem In-Befehl erkennen:
    reminder = IN(00007010h)
  until ((reminder AND 1) = 0)

  '............ read out result ............

  ADC = IN(00000200h)
ENDFUNCTION

'******************************************************************************
''' Samples, converts and reads out the digital ADC-value of an
'''+ analog input.
'''+ result: 24 bit integer
'''+ Attention:                                                                
'''+ This instruction is not prepared to handle an access from                 
'''+ a low AND high priority process to the same module.                       
''' adc_no: channel number of analog input
'''****************************************************************************
FUNCTION ADC24(adc_no) AS LONG

  DIM reminder AS LONG
  DIM muxtime AS LONG

  '............ set MUX ............
  OUT(5010h, (adc_no - 1))

  nops(4)

  '............ wait multiplexer settling time ........
  muxtime = IN(5022h)                                       '

  if (muxtime > 6) then
    SLEEP((muxtime / 5))
  endif

  '............ start conversion ............

  OUT(00007000h, 1)

  ' folgende nops sind erforderlich, aufgrund fpga-interner zwischentaktung
  ' zur Verbesserung des fpga-timings.
  ' => unkritisch, da sowieso gewartet wird !

  nops(3)                                                   ' Out-Datum steht am Beginn diese NOP bereits an  __|--
  ' Busy_adc (=STCONV) auf '1' zu Beginn dieses NOP ____|--
  ' Busy_out           auf '1' zu Beginn dieses NOP ______|--
  ' => Busy_out kann mit dem nchsten IN-Befehl gelesen werden

  '............ wait EOC ............
  do
    ' EOC, d.h. Busy_out='0' mit 1-Taktzyklus langem In-Befehl erkennen:
    reminder = IN(00007010h)
  until ((reminder AND 1) = 0)

  '............ read out result ............

  ADC24 = IN(00000000h)
ENDFUNCTION


'******************************************************************************
' Returns conversion result of ADC and starts immediately
''' a new conversion.
'''+ result: 16 bit long
'''****************************************************************************
FUNCTION Read_ADC_SConv() AS LONG
  Read_ADC_SConv = IN(00000300h)
ENDFUNCTION

'******************************************************************************
''' Returns conversion result of ADC and starts immediately
'''+ a new conversion.
'''+result: 24 bit long
'''****************************************************************************
FUNCTION Read_ADC_SConv24() AS LONG
  Read_ADC_SConv24 = IN(00000100h)
ENDFUNCTION


'******************************************************************************
'''return the input data (16 Bit Long)
''' channel:Input channel (1.16).
'''****************************************************************************
FUNCTION SEQ_Read(channel) as long
  SEQ_Read = IN(000001FFh + channel)
ENDFUNCTION

'******************************************************************************
'''return the input data (24 Bit Long)
''' channel:Input channel (1.16).
'''****************************************************************************
FUNCTION SEQ_Read24(channel) as long
  SEQ_Read24 = IN(-1 + channel)
ENDFUNCTION



'******************************************************************************
'''initialising the ain mode
'''mode:
'''+  0->normal Mode
'''+  1->single shot mode
'''+  2->continuous mode Eventdelay
'''+  3->continuous mode max Speed
'''gain:
'''+     0->range -10 V -> +10 V
'''+     1->range -5V   -> + 5 V
'''+     2->range -2.5V -> + 2.5 V
'''+     3->range -1.25 -> + 1.25 V
'''channel: selected channels in binary
'''mux_time: unit [20 ns] 0->default time
'''****************************************************************************
SUB SEQ_Init(mode, gain, channel, mux_time)
  dim i as Long
  dim anz as Long
  dim delay as Long
  dim imux as Long
  dim startdelay as Long

  dim modulcode as long

  anz = 0
  for i = 0 to 31
    if (shift_left(1, i) AND channel > 0) then inc anz
  next

  OUT(7020H, 0)                                             'stop

  SET_MUX(shift_left(gain, 8))                              'gain

  OUT(80805045H, channel)                                   'channel
  OUT(80805030H, 6)                                         'takt divisor
  
  if (mux_time <> 0) then
    imux = mux_time
  else
    imux = 250                                              '5   s       
  endif
  
  OUT(80805020H, imux)
 
  startdelay = (globaldelay) - ((anz * imux) + 100)
  sleep(1)

  if (startdelay < 0) then startdelay = 0
  if (mode = 3) then
    out(80805035H, 0)
    out(80805040H, 0)
    out(7020h, 3)                                           'continous
  else
    out(80805035H, startdelay)
    out(80805040H, globaldelay * 6)                         'startdelay
  
  
    if (mode = 2) then
      out(7020H, 3)                                         'mode
    else
      out(7020H, mode)                                      'mode
    endif
  endif

ENDSUB


'******************************************************************************
'''Start SEQ-Mode
'''****************************************************************************
SUB SEQ_Start()
  OUT(00007022h, 1)
ENDSUB


'******************************************************************************
''' Wait until SEQ
'''****************************************************************************
SUB SEQ_Wait()
  DIM reminder AS Long
  
  nops(3)
  DO
    reminder = in(7010H)
  UNTIL ((reminder AND 1) = 0)
ENDSUB

'******************************************************************************
''' READ LIMIT channel 1..16
'''****************************************************************************
FUNCTION ADC_Read_Limit() AS Long
  ADC_Read_Limit = in(7030H)
ENDFUNCTION


'******************************************************************************
''' Set Limit
''' channel: channel (1..16)
''' valueHIGH switch point to set limit overflow bit to 1
''' valueLOW switch point to set limit underflow bit to 1
'''****************************************************************************
SUB ADC_Set_Limit(channel, valuehigh, valuelow)
  out(808055FFH + channel, valueHigh)
  out(808054FFH + channel, valuelow)
  nops(3)
ENDSUB




'<ENDREGION>

'<REGION> DAC
'********************************** DAC ***************************************
''' convert the digitial value to an analog output
''' dac_no: channel number of analog output
''' value:  output value (0..65535)
'''****************************************************************************
SUB DAC(dac_no, value)
  out(022FFh + (dac_no), value)
ENDSUB

'******************************************************************************
''' Set DAC-register to desired value
''' DAC_No: channel number of analog output (1..8)
''' value:  output value (0..65535)
'''****************************************************************************
SUB Write_DAC(dac_no, value)
  out(21FFh + (DAC_No), value)
ENDSUB

' *****************************************************************************
''' Set DAC-register to desired value
''' DAC_No: 
'''+        0->Channel 1 and 2
'''         1->Channel 3 and 4
''' value: output value 32Bit
'''****************************************************************************
SUB Write_DAC32(dac_no, value)
  out(2400h + (dac_no), value)
ENDSUB


'******************************************************************************
''' Simultaneously start conversion of all DAC on this module.
'''****************************************************************************
SUB Start_DAC()
  out(7002h, 0)
ENDSUB
'<ENDREGION>

'<REGION> DIO ...

'******************************************************************************
''' Reads the digital inputs 
'''+ Return 
'''+                Bit 0...7 DIO 1 ... DIO 8
'''+Option ET1      
'''+                Bit 16-19  OPT 1 ... OPT 4 
'''****************************************************************************
FUNCTION MIO_Digin_Long() AS Long
  MIO_Digin_Long = IN(6520h)
ENDFUNCTION


'******************************************************************************
''' reads the input latch register 
'''+ Return 
'''+                Bit 0...7 DIO 1 ... DIO 8
'''+Option ET1      
'''+                Bit 16-19  OPT 1 ... OPT 4 
'''****************************************************************************
FUNCTION MIO_Dig_Read_Latch() AS Long
  MIO_Dig_Read_Latch = IN(6525h)
ENDFUNCTION

'******************************************************************************
''' Sets the digital outputs 
''' pattern : each bit corresponds to a channel
'''+          Bit 0...7    DIO 1 ... DIO 8
'''+Option ET1
'''+          Bit 24...27  TRA 1 ... TRA 4 
'''****************************************************************************
SUB MIO_Digout_Long(pattern)
  out(6500H, pattern)
ENDSUB


'******************************************************************************
''' sets output register 
''' pattern: each bit corresponds to a channel
'''+          Bit 0...7    DIO 1 ... DIO 8
'''+Option ET1
'''+          Bit 24...27  TRA 1 ... TRA 4
'''****************************************************************************
SUB MIO_Dig_Write_Latch(pattern)
  out(6505H, pattern)
ENDSUB

'******************************************************************************
''' latches the digital I/O module.
''' Inputs are latched in the input registers
''' Outputs are set according to the output register.
'''*****************************************************************************
SUB MIO_Dig_Latch()
  out(6515h, 0)
  nop
ENDSUB


'******************************************************************************
''' Sets or resets one channel of a digital output
''' channel: channel number (0...max channel-1)
'''+           0...7    DIO 1 ... DIO 8
'''+Option ET1
'''+           24...27  TRA 1 ... TRA 4 
''' value:   
'''+        0->reset channel
'''+        1->set channel
'''****************************************************************************
SUB MIO_Digout(channel, value)
  out(6511h - (value), shift_left(1, (channel)))
ENDSUB


'******************************************************************************
''' Initialisation of a digital I/O module 
'''  pattern : each bit corresponds to 4 channel
'''+     0->input
'''+     1->output
'''****************************************************************************
SUB MIO_DigProg(pattern)
  out(4100h, pattern)
ENDSUB

'******************************************************************************
''' read back of the output value of the digital outputs 
'''****************************************************************************
FUNCTION MIO_Get_Digout_Long() AS Long
  MIO_Get_Digout_Long = in(6500H)
ENDFUNCTION


'<ENDREGION>

'<REGION> CNT

'**************************************************************
''' read SSI encoder value 32 Bit
''' channel: number of the ssi decoder
'''************************************************************
FUNCTION SSI_Read(dcdr_no) AS long
  SSI_Read = in(000010C4H + dcdr_no)
ENDFUNCTION


'**************************************************************
''' sets the number of databits for the SSI Interface
''' dcdr_no: number of the ssi decoder
''' bit_no: number of bits
'''************************************************************
SUB SSI_Set_Bits(dcdr_no, bit_no)
  out(000010C2h + dcdr_no, bit_no)
ENDSUB


'**************************************************************
''' sets frequency of the SSI clock
''' prescale: frequency = 25MHZ / prescale
'''************************************************************
SUB SSI_Set_Clock(prescale)
  out(000010C2h, prescale)
ENDSUB


'**************************************************************
''' Starts the SSI interface
''' pattern: Bit combination each bit corresponds to one counter
'''************************************************************
SUB SSI_Start(pattern)
  out(000010C0H, pattern)
ENDSUB


'*************************************************************
''' Sets the SSI mode
''' pattern: Bit combination each bit corresponds to one counter
'''+ 0 = single start mode
'''+ 1 = continuous start mode
'''***********************************************************
sub SSI_Mode(pattern)
  out(000010C1H, pattern)
endsub

'*************************************************************
''' Reads the SSI status
''' dcdr_no: number of the SSI decoder
''' return value: 
'''+             0 = SSI value compleated
'''+             1 = SSI transfer running
'''***********************************************************
FUNCTION SSI_Status(dcdr_no) AS long
  dim value2 as long
  value2 = in(000010C0H)
  SSI_Status = shift_right(value2, dcdr_no - 1) AND 01H     'shift_right(value2, ((dcdr_no)-1)) AND 01H
ENDFUNCTION


'*************************************************************
''' Sets the delay in continuous mode
''' dcdr_no: number of the SSI decoder
''' delay: 16 Bit :  / 10 ns  [default 50s /512]
'''***********************************************************
SUB SSI_Set_Delay(dcdr_no, delay)
  out(000010C9h + dcdr_no, delay)
ENDSUB

'---------------------------------------------------------------
' If a low-priority process accesses must not be
' interrupted by any other process !!!
'------------------------------------------------------------5700---
Sub Sub_Begin_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  Begin_Critical_Section
#EndIf
EndSub

Sub Sub_End_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  End_Critical_Section
#EndIf
EndSub


'***************************************************************
'''set mode for counter
'''counter_no: number of the counter
'''mode:
'''+   Bit 0 CNT MODE 0= TAKT Richtung 1 = AB
'''+   Bit 1 CLEAR MODE 0= normal mode, 1 clear IF A=1 B=1 C=1
'''+   Bit 2 INV CLK 0=not invers, 1=invers
'''+   Bit 3 INV DIR 0=not invers, 1=invers
'''+   Bit 4 CLEAR or LATCH 0= C use for clear, 1 C use for latch
'''+   Bit 5 Ext Clear/Latch Enable 0= disable 1=enable
'''+   Bit 6 PWM Referenz Edge 0=positiv 1=negativ
'''+   Bit 7, 8 PWM INPUT_SELECT 00=A, 01=b, 10=C
'''*************************************************************
SUB CNT_Mode(counter_no, mode)
  
#If MAKE_LIB = ON Then
  #error("CNT_Mode does NOT work in Libraries!")
#else
  
  DIM modei as Long
  'POKE_FAST_BUS((3200109Fh+(counter_no) OR shift_left(module, 16)), mode)
  OUT((0000109Fh + (counter_no)), mode)
  modei = shift_right(mode, 6) AND 1
  PWM_help_mode = ((NOT (shift_left(1, counter_no - 1))) AND PWM_help_mode) OR shift_left(modei, counter_no - 1)

#endif

ENDSUB

'***************************************************************
''' activate / deactivate counter
''' pattern: Bit 0-3 VR counter Enable
'''*************************************************************
SUB CNT_Enable(pattern)
  out(000010B5h, pattern)
ENDSUB

'***************************************************************
''' activate / deactivate counter
''' pattern: Bit 0-3 VR PW Counter Enable
'''*************************************************************
SUB CNT_PW_Enable(pattern)
  out((000010B6h), pattern)
ENDSUB

'***************************************************************
''' latch counter value to register
''' pattern: each bit corresponds to a counter
'''*************************************************************
SUB CNT_Latch(pattern)
  out((000010B0h), pattern)
  nops(4)
ENDSUB

'***************************************************************
''' read latch register
''' counter_no: number of the counter
'''*************************************************************
FUNCTION CNT_Read_Latch(counter_no) as Long
  CNT_Read_Latch = in((00000FF6h + (counter_no) * 16))
ENDFUNCTION

'**************************************************************
''' latch counter to register and read counter value
''' counter_no: number of the counter
'''************************************************************
FUNCTION CNT_Read(counter_no) as Long
  out((000010B0h), shift_left(1, counter_no - 1))
  nops(4)
  CNT_Read = in((00000FF6h + (counter_no) * 16))
ENDFUNCTION

'***************************************************************
''' reset counter
''' pattern: each bit corresponds to a counter
'''*************************************************************
SUB CNT_Clear(pattern)
  out(000010B1h, pattern)
ENDSUB

'**************************************************************
''' reads the status of a counter input
'''+ return :
'''+          Bit 0= A/CLK Input
'''+          Bit 1= B Input
'''+          Bit 2= C/L Input
'''+          Bit 3=Cable error
'''+          Bit 4=Phase error
''' counter_no: number of the counter
'''************************************************************
FUNCTION CNT_Get_Status(counter_no) as Long
  CNT_Get_Status = in(00000FFFh + (counter_no) * 16)
ENDFUNCTION

'FUNCTION for spezial user
'''+returns the content of a counter register.
'''Counter number: 1.4.
'''regNr:
'''+    0 pos_pwm_latch 1
'''+    1 pos_pwm_latch 2
'''+    2 pos_pwm_latch 3
'''+    3 neg_pwm_latch 1
'''+    4 neg_pwm_latch 2
'''+    5 neg_pwm_latch 3
'''+    6 vr latch
'''+    7 pwm latch
'''+    8 pos_pwm_latch 1 shadow
'''+    9 pos_pwm_latch 2 shadow
'''+   10 pos_pwm_latch 3 shadow
'''+   11 neg_pwm_latch 1 shadow
'''+   12 neg_pwm_latch 2 shadow
'''+   13 neg_pwm_latch 3 shadow
'''+   14 vr_latch shadow
'''+   15 status
'''***************************************************************
FUNCTION CNT_Read_INT_Register(counter_no, regnr) as Long
  CNT_Read_INT_Register = in(00000FF0h + regnr + (counter_no) * 16)
ENDFUNCTION

'***************************************************************
'''The instruction Cnt_PW_Latch is valid for several ADwin devices
''' pattern: each bit corresponds to a counter
'''*************************************************************
SUB CNT_PW_Latch(pattern)
  out(000010B2h, pattern)
  nops(4)
ENDSUB

'***************************************************************
''' latch vr and pw counter to shadow register
''' pattern: each bit corresponds to a counter
'''*************************************************************
SUB CNT_SYNC_Latch(pattern)
  out(000010CFh, pattern)
  nops(4)
ENDSUB



'**************************************************************
'read pw frequency and dutycycle use cnt_pw_latch before
'by val counter_no
'by ref frequency as long
'by ref dutycycle as long
'**************************************************************
SUB CNT_Get_PW(counter_no, frequency, dutycycle) ''<HIDE> use from TiCo CNT_Get_PW_HL
#If MAKE_LIB = ON Then
  #error("CNT_Get_PW does NOT work in Libraries!")
#else
  DIM period as Long
  DIM puls as Long
  DIM ref_edge as Long

  DIM AR1, AR2, AR3, AR4, AR5 as long

  AR2 = in(00000FF9h + 1 + (counter_no) * 16)
  'AR3=in(00000FF9h+2+(counter_no)*16)

  AR5 = in(00000FF9h + 4 + (counter_no) * 16)

  ref_edge = shift_right(PWM_help_mode, counter_no - 1) AND 1

  IF (ref_edge = 1) then                                    'negative referenz edge
    AR4 = in(00000FF9h + 3 + (counter_no) * 16)
    period = AR4 - AR5                                      'neg2-neg3
    puls = AR4 - AR2                                        'neg2-pos3
  ELSE                                                      'positive referenz edge
    AR1 = in(00000FF9h + 0 + (counter_no) * 16)

    period = AR1 - AR2                                      'pos2-pos3
    puls = AR5 - AR2                                        'neg3-pos3
  ENDIF

  if (period <> 0) then
    frequency = 100000000 / period                          'Frequenz [Hz] '100 MHz
    dutycycle = puls * 100 / (period)                       'PWM Verhltnis
  else
    frequency = 0
    dutycycle = 0
  endif
#endif
ENDSUB

'**************************************************************
'''The instruction Cnt_Get_PW_HL is valid for several ADwin devices.
'''counter_no: Number (1.4) of PW counter
'''hightime: Pulse duration in units of 10 ns: PWM high level time by_ref
'''lowtime: Pulse period in units of 10 ns: PWM low level time by_ref
'''*************************************************************
SUB CNT_Get_PW_HL(counter_no, hightime, lowtime)
#If MAKE_LIB = ON Then
  #error("CNT_Get_PW_HL does NOT work in Libraries!")
#else
  DIM ref_edge as Long
  DIM AR1, AR2, AR3, AR4, AR5 as long

  
  AR2 = in(00000FF9h + 1 + (counter_no) * 16)
  ' AR3=in(00000FF9h+2+(counter_no)*16)

  AR5 = in(00000FF9h + 4 + (counter_no) * 16)


  ref_edge = shift_right(PWM_help_mode, counter_no - 1) AND 1

  IF (ref_edge = 1) then                                    'negative referenz edge
    '  period=neg2-neg3
    AR4 = in(00000FF9h + 3 + (counter_no) * 16)
    hightime = AR4 - AR2                                    'neg2-pos3
    lowtime = AR2 - AR5                                     'pos3-neg3
  ELSE                                                      'positive referenz edge
    ' period=pos2-pos3
    AR1 = in(00000FF9h + 0 + (counter_no) * 16)
    hightime = AR5 - AR2                                    'neg3-pos3
    lowtime = AR1 - AR5                                     'pos2-neg3
  ENDIF

#endif
ENDSUB

'<ENDREGION>

'<REGION> EtherCAT

'8 bit access
sub MIO_ECAT_Set_Reg_8(adr, val)                            '<HIDE>
  dim status as long
  dim t_adr, t_val as long
  
  t_val = val and 0FFh
  t_val = t_val or shift_left(val, 8)
  t_adr = adr and 0FFFFh                                    '17.bit -> BHE 0
  If ((adr and 1) = 0) Then
    t_adr = t_adr or 10000h                                 '17.bit -> BHE 1
  EndIf
  OUT(0df00h, t_adr)
  OUT(0df02H, t_val)
  do 
    status = in(0df10H)
  until (status >= 0)
endsub

'8 bit access
function MIO_ECAT_Get_Reg_8(adr) as long                    '<HIDE>
  dim status as long
  dim t_adr as long
  
  t_adr = adr and 0FFFFh                                    '17.bit -> BHE 0
  If ((adr and 1) = 0) Then
    t_adr = t_adr or 10000h                                 '17.bit -> BHE 1
  EndIf
  OUT(0df10h, t_adr) 
  nop
  do
    status = in(0df10H)
  until (status >= 0)
  MIO_ECAT_Get_Reg_8 = status and 0FFh
endfunction

'16 bit access
sub MIO_ECAT_Set_Reg(adr, val)                              '<HIDE>
  dim status as long
  OUT(0df00h, adr)
  OUT(0df02H, val)
  do 
    status = in(0df10H)
  until (status >= 0)
endsub

'16 bit access
function MIO_ECAT_Get_Reg(adr) as long                      '<HIDE>
  OUT(0df10h, adr) 
  nop
  do
    MIO_ECAT_Get_Reg = in(0df10H)
  until (MIO_ECAT_Get_Reg >= 0)
endfunction

'32 bit access
Function MIO_ECAT_Read_32(adr) As Long                      '<HIDE>
  Dim tmp As Long
  ' in case address is a complex expression, storing it in a variable
  ' speeds up the access
  tmp = adr
  ' read low word, read high word, shift high word, and OR the results together
  MIO_ECAT_Read_32 = MIO_ECAT_Get_Reg(tmp) OR shift_left(MIO_ECAT_Get_Reg(tmp + 2), 16)
EndFunction

'32 bit access
Sub MIO_ECAT_Write_32(adr, val)                             '<HIDE>
  Dim tmp as Long
  ' in case address is a complex expression, storing it in a variable
  ' speeds up the access
  tmp = adr
  ' Write low word.
  MIO_ECAT_Set_Reg(tmp, val AND 0ffffh)
  ' Write high word.
  MIO_ECAT_Set_Reg(tmp + 2, shift_right(val, 16))
EndSub

'******************************************************************************
'Bit     0  : 0=ERROR-LED aus, 1=ERROR_LED an
'Bit  3..1  : -
'Bit  4..7  : pulsbreite pb x50[ms]
'Bit 15..8  : pause pa x50[ms]
'Bit 19..16 : pulszahl n, ! 0fH = blinken ohne Unterbrechung !
'Bit 31..17 : -
'******************************************************************************
SUB MIO_ECAT_ErrLED(pattern)                                '<HIDE>
  out(0DF1AH, pattern)                                 
ENDSUB

'******************************************************************************
'* \brief Initialize the EtherCAT controller. 
'* This function must be called at least 
'* once before accessing the controller with other functions.
'* \return  0 on success
'*         -1 on error
'******************************************************************************
Function MIO_ECAT_Init() As Long 
  dim tmp as long
  ' check the reset value of the Type register (address 0)
  If (MIO_ECAT_Get_Reg(ECAT_REG_Type) And 0ffh <> ECAT_REG_TYPE_RESET_VALUE) Then
    MIO_ECAT_Init = -1
  Else
    MIO_ECAT_Init = 0
    mio_ecat_errled(ECAT_BP_OFF)

    tmp = MIO_ECAT_Get_Reg(ECAT_REG_AL_Status) and 0FEFFh
    MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, tmp)               ' clear err flag
    MIO_ECAT_Set_Reg(ECAT_REG_AL_Status_Code, 0h)           ' clear error code

  EndIf
EndFunction

'******************************************************************************
' Copy EtherCAT_Input[1] to EtherCAT_Input[16] into ecat_inputs[1] to ecat_inputs[16].
' Returns:  0 on success
'          -1 if EtherCAT state is insufficient
'******************************************************************************
Function MIO_ECAT_Read_Data_16L(ecat_inputs[]) As Long
  Dim i, tmp As Long
  ' Check if the current state allows us to read data. Reading data (For us)
  ' is only allowed in Operational state.
  tmp = MIO_ECAT_Get_Current_ECAT_State()
  If (tmp <> ECAT_STATE_OP) then
    ' We are not allowed to read data yet.
    MIO_ECAT_Read_Data_16L = -1
  Else
    ' We are in Operational state.
    For i = 0 to ECAT_RXPDO_COUNT_16L - 1
      ecat_inputs[i + 1] = MIO_ECAT_Read_32((ECAT_RXPDO_START + i * 4))
    Next
    MIO_ECAT_Read_Data_16L = 0
  EndIf
EndFunction


'******************************************************************************
' Copy ecat_outputs[1] to ecat_outputs[16] into EtherCAT_Output[1] to EtherCAT_Output[16].
' Returns:  0 on success
'          -1 if EtherCAT state is insufficient
'******************************************************************************
Function MIO_ECAT_Write_Data_16L(ecat_outputs[]) As Long
  Dim i, tmp_addr, tmp_val, tmp As Long
  ' Check if the current state allows us to write data. Writing data (For us) 
  ' is only allowed in Safe-Op and Operational state.
  tmp = MIO_ECAT_Get_Current_ECAT_State()
  If ((tmp <> ECAT_STATE_OP) and (tmp <> ECAT_STATE_SAFEOP)) then
    ' We are not allowed to write data yet.
    MIO_ECAT_Write_Data_16L = -1
  Else
    ' We are in Operational state.
    ' Write the actual data.
    For i = 0 to ECAT_TXPDO_COUNT_16L - 1
      MIO_ECAT_Write_32((ECAT_TXPDO_START + i * 4), ecat_outputs[i + 1])
    Next
    MIO_ECAT_Write_Data_16L = 0
  EndIf
EndFunction


'******************************************************************************
' Determine driver version
' Returns: High 16 bits = major version number
'          low 16 bits = minor version number
'******************************************************************************
Function MIO_ECAT_Get_Version() As Long
  MIO_ECAT_Get_Version = shift_left(ECAT_DRIVER_VERSION_MAJOR, 16) | ECAT_DRIVER_VERSION_MINOR
EndFunction


'******************************************************************************
' Get the current EtherCAT state
'
' Returns: current EtherCAT state 
'******************************************************************************
Function MIO_ECAT_Get_Current_ECAT_State() As Long          '<HIDE>
  MIO_ECAT_Get_Current_ECAT_State = MIO_ECAT_Get_Reg(ECAT_REG_AL_Status) & 0fh
EndFunction


'******************************************************************************
' Get the requested EtherCAT state
'
' Returns: requested EtherCAT state 
'******************************************************************************
Function MIO_ECAT_Get_Requested_ECAT_State() As Long        '<HIDE>
  MIO_ECAT_Get_Requested_ECAT_State = MIO_ECAT_Get_Reg(ECAT_REG_AL_Control) & 0fh
EndFunction

'******************************************************************************
' Check whether the master requested a state change and confirm the state change
'
' Returns: current EtherCAT state (after transition)
' Note: In this function, one can insert function calls functions based on 
'       state changes
'******************************************************************************
Function MIO_ECAT_Check_State_Transition() As Long
  Dim Requested_State, Current_State As Long
  Requested_State = MIO_ECAT_Get_Requested_ECAT_State()
  Current_State = MIO_ECAT_Get_Current_ECAT_State()
  MIO_ECAT_Check_State_Transition = Current_State
  
  if ((MIO_ECAT_Get_Reg(ECAT_REG_AL_Control) and 10h) <> 0) then
    MIO_ECAT_Set_Reg(ECAT_REG_AL_Status_Code, 0h)           ' clear error code
    MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, Current_State and 0Fh)  ' clear err flag
    mio_ecat_errled(ECAT_BP_OFF)
  endif
  
  SelectCase Current_State
    Case ECAT_STATE_INIT
      SelectCase Requested_State
        Case ECAT_STATE_INIT
          ' nothing to do.
        Case ECAT_STATE_PREOP
          ' go to PREOP
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, ECAT_STATE_PREOP)
        Case ECAT_STATE_BOOT
          'Err LED
          if ((MIO_ECAT_Get_Reg(ECAT_REG_AL_Status) and 10h) = 0) then mio_ecat_errled(ECAT_BP_BLINKING)
          ' Bootstrap not supported
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, ECAT_STATE_INIT)
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status_Code, 013h)
        CaseElse
          'Err LED
          if ((MIO_ECAT_Get_Reg(ECAT_REG_AL_Status) and 10h) = 0) then mio_ecat_errled(ECAT_BP_BLINKING)
          ' invalid transition
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, Current_State | 010h)
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status_Code, 012h)
      EndSelect
    Case ECAT_STATE_PREOP
      SelectCase Requested_State 
        Case ECAT_STATE_INIT
          ' go to INIT
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, ECAT_STATE_INIT)
        Case ECAT_STATE_PREOP
          ' nothing to do
        Case ECAT_STATE_SAFEOP
          ' go to SAFEOP
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, ECAT_STATE_SAFEOP)
        CaseElse
          'Err LED
          if ((MIO_ECAT_Get_Reg(ECAT_REG_AL_Status) and 10h) = 0) then mio_ecat_errled(ECAT_BP_BLINKING)
          ' invalid transition
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, Current_State | 010h)
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status_Code, 012h)
      EndSelect
    Case ECAT_STATE_BOOT
      'Err LED
      if ((MIO_ECAT_Get_Reg(ECAT_REG_AL_Status) and 10h) = 0) then mio_ecat_errled(ECAT_BP_BLINKING)
      ' we do not support BOOTSTRAP, so this should never happen. 
      ' we go back to INIT and set Bootstrap_not_supported.
      MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, ECAT_STATE_INIT | 010h)
      MIO_ECAT_Set_Reg(ECAT_REG_AL_Status_Code, 013h)
    Case ECAT_STATE_SAFEOP
      SelectCase Requested_State 
        Case ECAT_STATE_INIT
          ' go to INIT
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, ECAT_STATE_INIT)
        Case ECAT_STATE_PREOP
          ' go to PREOP
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, ECAT_STATE_PREOP)
        Case ECAT_STATE_SAFEOP
          ' nothing to do
        Case ECAT_STATE_OP
          ' go to OP
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, ECAT_STATE_OP)
        CaseElse
          'Err LED
          if ((MIO_ECAT_Get_Reg(ECAT_REG_AL_Status) and 10h) = 0) then mio_ecat_errled(ECAT_BP_BLINKING)
          ' invalid transition
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, Current_State | 010h)
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status_Code, 012h)
      EndSelect
    Case ECAT_STATE_OP
      SelectCase Requested_State 
        Case ECAT_STATE_INIT
          ' go to INIT
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, ECAT_STATE_INIT)
        Case ECAT_STATE_PREOP
          ' go to PREOP
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, ECAT_STATE_PREOP)
        Case ECAT_STATE_SAFEOP
          ' go to SAFEOP
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, ECAT_STATE_SAFEOP)
        Case ECAT_STATE_OP
          ' nothing to do
        CaseElse
          'Err LED
          if ((MIO_ECAT_Get_Reg(ECAT_REG_AL_Status) and 10h) = 0) then mio_ecat_errled(ECAT_BP_BLINKING)
          ' invalid transition
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, Current_State | 010h)
          MIO_ECAT_Set_Reg(ECAT_REG_AL_Status_Code, 012h)
      EndSelect
    CaseElse
      'Err LED
      if ((MIO_ECAT_Get_Reg(ECAT_REG_AL_Status) and 10h) = 0) then mio_ecat_errled(ECAT_BP_BLINKING)
      ' error
      MIO_ECAT_Set_Reg(ECAT_REG_AL_Status, ECAT_STATE_INIT | 010h)
      MIO_ECAT_Set_Reg(ECAT_REG_AL_Status_Code, ECAT_STATE_INIT | 012h)
  EndSelect
EndFunction

'<ENDREGION>
