#ifndef __ADCONFIG_H__
#define __ADCONFIG_H__

/* ADwin specific includes */
#include <libadwin.h>
#include <linux/adwin.h>
#include <libadwin/types.h>

extern adwin_dev_t add_dev;
extern int del_dev;

#include <arpa/inet.h>

struct yy_config {
	int32_t cmd;				/* == 100 */
	int32_t structVersion;			/* == 100 */
	unsigned char hwaddr[8];				/* MAC */
	unsigned char ip[8], mask[8], gateway[8];	/* kompatibel zu WIN-Vorgaben :( */
	int32_t dhcp;
	int32_t port;
	char pw[10];
	char bootloader;
	char padding[5];
	char desc[16];
	int32_t unused[5];
};

extern int add(void);
extern int del(void);
extern int config(void);

extern int (*callback)(void);

#endif
