
#ifndef __ADWIN_LINK_H__
#define __ADWIN_LINK_H__

#include <linux/byteorder/generic.h>

#include <asm/io.h>
#define READ_STATUS(base_addr)  ((inb(base_addr+2) == 1) ? 0 : -EACCES)
#define WRITE_STATUS(base_addr) ((inb(base_addr+3) == 1) ? 0 : -EACCES)

extern int reset_link(wait_queue_head_t *q, int base_addr);
extern int adwin_read(struct file *filp, char *usr_buf, size_t count, loff_t *ppos);
extern int adwin_write(struct file *filp, const char *usr_buf, size_t count, loff_t *ppos);

extern void adwin_timeout(unsigned long __data);

extern int debug;

static __inline__ int __to_link_dsp(unsigned char *byte, int base_addr) {
	int i;

	struct timer_list timer;
	volatile long timeout_flag = 0;

	for (i = 0; (i < 100) && WRITE_STATUS(base_addr); i++);

	if (i < 100) {
		DEBUG(2, "%02X ", *byte);
		outb(*byte, base_addr + 1);
		return 0;
	}

	init_timer(&timer);
	timer.expires  = jiffies + 25;
	timer.data     = (unsigned long) &timeout_flag;
	timer.function = adwin_timeout;

	add_timer(&timer);
	while(! timeout_flag) {
		if (WRITE_STATUS(base_addr) != -EACCES) {
			DEBUG(2, "%02X ", *byte);
			outb(*byte, base_addr + 1);
			break;;
		} else
			schedule();
	}
	del_timer_sync(&timer);

	if (timeout_flag) {
		DEBUG(2, "\n");
		DEBUG(1, "ADwin debug: timed out\n");
		return -ETIMEDOUT;
	}
	return 0;
}


#endif
